require "james_bond/core/config"
require "james_bond/core/mission_loader"
require "james_bond/core/command"
require "james_bond/core/mission"

module JamesBond
  module Core
    DEFAULT_ENVIRONMENT = "dev".freeze

    class << self
      def run_command(argv, env=DEFAULT_ENVIRONMENT)
        config       = load_config
        mission_pool = MissionLoader.load_missions(config.missions)
        command      = Command.new(argv: argv, env:  env)
        command      = Command.new(argv: ["help"], env:  env) if command.empty?

        winning_mission = mission_pool.decide_mission(command)
        winning_mission.run_command(command: command, mission_pool: mission_pool)
      end

      private

      def load_config
        yaml_path = File.join(Dir.pwd, "config", "james_bond.yml")
        JamesBond::Core::Config.new(yaml_path: yaml_path)
      end
    end
  end
end
