module JamesBond
  module Core
    class Command
      RESERVED_COMMANDS = ["env", "run", "server", "test", "deploy", "console"].freeze

      attr_accessor :argv,
                    :user_command,
                    :main_command,
                    :raw_arguments,
                    :arguments_string,
                    :env,
                    :options

      def initialize(argv:, env:)
        @argv             = argv
        @user_command     = argv.join(" ")
        @main_command     = argv.first
        @raw_arguments    = argv.drop(1)
        @arguments_string = @raw_arguments.join(" ")
        @env              = env
      end

      def empty?
        @argv.empty?
      end
    end
  end
end
