require "yaml"

module JamesBond
  module Core
    class Config
      ENV_PLACEHOLDER   = ":env".freeze
      RESERVED_COMMANDS = ["env", "run", "server", "test", "deploy", "console"].freeze

      attr_accessor :yaml_path,
                    :raw_hash,
                    :missions

      def initialize(params={})
        @yaml_path = params[:yaml_path]

        extract_config_from_yaml(@yaml_path)
      end

      private

      def extract_config_from_yaml(yaml_path)
        @raw_hash = YAML.load(File.read(yaml_path))
        @missions = @raw_hash["missions"]

        validate_config
      end

      def validate_config
        raise "Please provide at least one mission to work with 007!" if !@missions || @missions.empty?
      end
    end
  end
end
